// FileWriter.h: CFileWriter NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "MediaDecoder.h"
#include "NCachedFile.h"


/////////////////////////////////////////////////////////////////////////////
// ėpt@Co(CMediaDatâ܂܃t@Cɏo)
/////////////////////////////////////////////////////////////////////////////
// Input	#0	: CMediaData		݃f[^
/////////////////////////////////////////////////////////////////////////////

class CFileWriter : public CMediaDecoder
{
public:
	enum EVENTID
	{
		EID_WRITE_ERROR
	};

	CFileWriter(IEventHandler *pEventHandler = NULL);
	virtual ~CFileWriter();

// IMediaDecoder
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CFileWriter
	// Modified by HDUSTest̒̐l
	// tOwł悤ɂ
	// const bool OpenFile(LPCTSTR lpszFileName);
	enum { CNF_CALCCRC=0x80 };
	const bool OpenFile(LPCTSTR lpszFileName, BYTE bFlags = 0);
	void CloseFile(void);
	const bool IsOpen() const;

	const LONGLONG GetWriteSize(void) const;
	const LONGLONG GetWriteCount(void) const;

	// Append by HDUSTest̒̐l
	bool SetBufferSize(DWORD Size);
	DWORD GetBufferSize() const { return m_BufferSize; }
	bool Pause();
	bool Resume();
	LPCTSTR GetFileName() const;
	DWORD GetCrc() const;
protected:
	CNCachedFile m_OutFile;
	DWORD m_BufferSize;

	LONGLONG m_llWriteSize;
	LONGLONG m_llWriteCount;

	bool m_bWriteError;
	bool m_bPause;

	bool m_bCalcCrc;
	DWORD m_CurCrc;
};
